#pragma once

#include <stdlib.h>
#include "Matrix.h"
#include "Vector.h"

class ALSEngine {
  public:
    ALSEngine(
      Matrix ratingMatrix,
      Matrix userFactors,
      Matrix itemFactors,
      double regularization,
      size_t iterations
    );

    ALSEngine(
      Matrix ratingMatrix,
      double alpha,
      double regularization,
      size_t factors,
      size_t iterations,
      size_t seed
    );

    Matrix train();

  private:

    void solver(Matrix& Cui, Matrix& X, Matrix& Y, double regularization);

    size_t numUsers;
    size_t numItems;

    Matrix ratingMatrix;
    Matrix userFactors;
    Matrix itemFactors;

    double alpha;
    double regularization;

    size_t factors;
    size_t iterations;
    size_t seed;
};
